 /******************** (C) COPYRIGHT 2008 STMicroelectronics ********************
* File Name          : main.c
* Author             : MCD Application Team
* Version            : V2.0
* Date               : 05/23/2008
* DescriptWHY8W-QT9DJ-P0VNX-L15PE-W4DCR-VP3FMion        : Main program body
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
* FOR MORE INFORMATION PLEASE CAREFULLY READ THE LICENSE AGREEMENT FILE LOCATED 
* IN THE ROOT DIRECTORY OF THIS FIRMWARE PACKAGE.
*******************************************************************************/
					                
/* Includes ------------------------------------------------------------------*/
#include "config.h"	 
#include "ads7843drv.h"	 
#include "ili9325.h"  
#include "delay.h"
#include "SD_driver.h"
#include "vs1003.h"
#include "mp3.h"

WCHAR *GBKTOUnicode(unsigned char *ch) ;
BOOL SD_TotalSize(void);
void scan_current_folder(const char* path);
u8 MusicNumber;
u8 temp;
u8 count=0;
extern matrix mat ;
extern coordinate  display ;

EXTI_InitTypeDef EXTI_InitStructure;
GPIO_InitTypeDef GPIO_InitStructure;
u32 datasize=0;	   //

#define ADC1_DR_Address    ((u32)0x4001244C)   
vu16 ADCConvertedValue;
int AD_value;
u8 vol;
u16 volt;
FATFS fs;            // Work area (file system object) for logical drive
FIL fsrc, fdst,fap,file;      // file objects
 FRESULT res,re;         // FatFs function common result code
 UINT br, bw,bt;;         // File R/W count
FILINFO finfo,fno;
DIR dirs;

extern u8 LrcEnable;
u8 buffer[1024]; // file copy buffer
u8 data[512];
extern u8 tag_table[512];
u8 flag=0;
extern Touch_Key  Touch_Pen;

ErrorStatus HSEStartUpStatus;
void RCC_Configuration(void);
void NVIC_Configuration(void);
void TIM_Configuration(void);
void USART_Configuration(void);
u8 FindMusic(void);
void ADC_Configuration(void);


int main(void)
{

u8 i;
#ifdef DEBUG
    debug();
#endif
  RCC_Configuration(); 

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

  /* Enable ADC1 and GPIOC clock */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 | RCC_APB2Periph_GPIOA, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
  
  /* Enable GPIOC clock */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOC|RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE, ENABLE);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOC, &GPIO_InitStructure);  
  GPIO_ResetBits(GPIOC,GPIO_Pin_8);	//SD
	 /* NVIC Configuration */
  NVIC_Configuration();	
  ADC_Configuration();
  	TP_Init(); 
 
  delay_init(72);    //72Mʱʼ
  SPI_Configuration();
  Vs1003_Init(); 

  Lcd_Initialize();
  SD_Init();	 
  Vs1003SoftReset();
  LoadPatch(); 
//    Lcd_Clear(0X07FF);
to:	f_mount(0,&fs);
    temp= FindMusic();
	MusicNumber=temp;
	bw = f_open(&fsrc,head->filename,FA_OPEN_EXISTING | FA_READ);
	setCalibrationMatrix(&DisplaySample[0],&ScreenSample[0],&mat);
	Lcd_ColorBox(0,0,240,160,0);
	Lcd_ColorBox(0,160,240,160,0xffff);
   while(1)
    { 	
	if(count++==20)
	{
	 count=0;
	 AD_value=ADC_GetConversionValue(ADC1);
     AD_value=(AD_value*330)/4096;
	 vol=(AD_value*255)/330;	 
	 vol=abs(vol-255);
	 volt=vol;
     volt<<=8;
     volt+=vol;//õúС   
     Vs1003_CMD_Write(SPI_VOL,volt); //
	 }

	Touch_Coordinate();
	if(datasize>=fsrc.fsize)
	flag=1;
	
	if(Is_In_Area(0,0,240,160))  //NEXT
	{  

	 delay_ms(3000);
      flag=1;
	  Touch_Pen.NowX=500;
	  Touch_Pen.NowY=500;
	}
	if(Is_In_Area(0,160,240,320))  //BACK
	{
	delay_ms(3000);
	 flag=1;
	 MusicNumber++;
	 if(MusicNumber==temp+1)
	 {
	 while(head->next!=NULL)
	 head=head->next;
	 head=head->back;
	 MusicNumber=1;
	 }
	 else
	 {
	 if(MusicNumber!=temp)
	 {
	 head=head->back;
	 head=head->back;
	 }
	 else
	 {
	 Touch_Pen.NowX=500;
	  Touch_Pen.NowY=500; 
	   flag=0;
	   datasize=0;
	  goto to;
	   
 	 }
	  }
	  MusicNumber++;
	 	  Touch_Pen.NowX=500;
	  Touch_Pen.NowY=500;
	}

 	if(flag==1)  //ļ
	{
	flag=0;
	if( (MusicNumber--) &&(head!=NULL) )	 //һļ
	{
	if(MusicNumber==0)	 //ļ
	{
	while(head->back!=NULL)
	head=head->back;
	}
	if(MusicNumber!=0)
	head=head->next;
	else
    MusicNumber=temp;
		bw = f_open(&fsrc,head->filename,FA_OPEN_EXISTING | FA_READ);
		datasize=0;
	}	
	}
	datasize+=512;	         //Ҫŵ
    bw = f_read(&fsrc,buffer,512,&br);
	 for(i=0;i<16;i++)
     {	 
	 while(!(GPIOC->IDR & MP3_DREQ)); 
	 Vs1003_DATA_Write(buffer+i*32);
 	 }		
   }
}								                  
#ifdef  DEBUG
/*******************************************************************************
* Function Name  : assert_failed
* Description    : Reports the name of the source file and the source line number
*                  where the assert_param error has occurred.
* Input          : - file: pointer to the source file name
*                  - line: assert_param error line source number
* Output         : None
* Return         : None
*******************************************************************************/
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/******************* (C) COPYRIGHT 2008 STMicroelectronics *****END OF FILE****/

/*******************************************************************************
* Function Name  : RCC_Configuration
* Description    : Configures the different system clocks.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/


void RCC_Configuration(void)
{
  /* RCC system reset(for debug purpose) */
  RCC_DeInit();

  /* Enable HSE */
  RCC_HSEConfig(RCC_HSE_ON);

  /* Wait till HSE is ready */
  HSEStartUpStatus = RCC_WaitForHSEStartUp();

  if(HSEStartUpStatus == SUCCESS)
  {
    /* Enable Prefetch Buffer */
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    /* Flash 2 wait state */
    FLASH_SetLatency(FLASH_Latency_2);
 	
    /* HCLK = SYSCLK */
    RCC_HCLKConfig(RCC_SYSCLK_Div1); 
  
    /* PCLK2 = HCLK */
    RCC_PCLK2Config(RCC_HCLK_Div1); 

    /* PCLK1 = HCLK/2 */
    RCC_PCLK1Config(RCC_HCLK_Div2);

    /* PLLCLK = 8MHz * 9 = 72 MHz */
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);

    /* Enable PLL */ 
    RCC_PLLCmd(ENABLE);

    /* Wait till PLL is ready */
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {
    }

    /* Select PLL as system clock source */
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    /* Wait till PLL is used as system clock source */
    while(RCC_GetSYSCLKSource() != 0x08)
    {
    }
  }
}

/*******************************************************************************
* Function Name  : NVIC_Configuration
* Description    : Configures Vector Table base location.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void NVIC_Configuration(void)
{
			
  NVIC_InitTypeDef NVIC_InitStructure;					 
#ifdef  VECT_TAB_RAM  
  /* Set the Vector Table base location at 0x20000000 */ 
  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
#else  /* VECT_TAB_FLASH  */
  /* Set the Vector Table base location at 0x08000000 */ 
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
#endif
NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0); 
NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQChannel;    //¼ 
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;   //ռȼ0 
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;          //Ӧȼ1 
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;             //ж 
NVIC_Init(&NVIC_InitStructure);                             //д 

	/*		  
   	
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
  
  NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);		*/
}

void ADC_Configuration(void)
{

ADC_InitTypeDef ADC_InitStructure;
DMA_InitTypeDef DMA_InitStructure;

GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
GPIO_Init(GPIOC, &GPIO_InitStructure);

  DMA_DeInit(DMA1_Channel1);
  DMA_InitStructure.DMA_PeripheralBaseAddr = ADC1_DR_Address;
  DMA_InitStructure.DMA_MemoryBaseAddr = (u32)&ADCConvertedValue;
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
  DMA_InitStructure.DMA_BufferSize = 1;
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Disable;
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
  DMA_Init(DMA1_Channel1, &DMA_InitStructure);
  
  /* Enable DMA1 channel1 */
  DMA_Cmd(DMA1_Channel1, ENABLE);
    
  /* ADC1 configuration ------------------------------------------------------*/
  ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;
  ADC_InitStructure.ADC_ScanConvMode = ENABLE;
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
  ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  ADC_InitStructure.ADC_NbrOfChannel = 1;
  ADC_Init(ADC1, &ADC_InitStructure);

  /* ADC1 regular channel14 configuration */ 
  ADC_RegularChannelConfig(ADC1, ADC_Channel_15, 1, ADC_SampleTime_55Cycles5);

  /* Enable ADC1 DMA */
  ADC_DMACmd(ADC1, ENABLE);
  
  /* Enable ADC1 */
  ADC_Cmd(ADC1, ENABLE);

  /* Enable ADC1 reset calibaration register */   
  ADC_ResetCalibration(ADC1);
  /* Check the end of ADC1 reset calibration register */
  while(ADC_GetResetCalibrationStatus(ADC1));

  /* Start ADC1 calibaration */
  ADC_StartCalibration(ADC1);
  /* Check the end of ADC1 calibration */
  while(ADC_GetCalibrationStatus(ADC1));
     
  /* Start ADC1 Software Conversion */ 
  ADC_SoftwareStartConvCmd(ADC1, ENABLE);

}


void TIM_Configuration(void) 
{ 
TIM_TimeBaseInitTypeDef TIM_BaseInitStructure; 

TIM_DeInit( TIM2);                              //λTIM2ʱ 
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);      
//TIM1 ʹڲʱ 
//TIM_InternalClockConfig(TIM1); 
//TIM1 
//ԤƵƵϵ71APB2=72M, TIM1_CLK=72/72=1MHz 
//TIM_PeriodTIM1_ARR=1000ϼ1000¼ֵ 
//ϼģʽ 
//TIM_RepetitionCounter(TIM1_RCR)=0ÿ¼ 
TIM_BaseInitStructure.TIM_Period = 30000; 
TIM_BaseInitStructure.TIM_Prescaler = 71; 
TIM_BaseInitStructure.TIM_ClockDivision = 0; 
TIM_BaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up; 
TIM_BaseInitStructure.TIM_RepetitionCounter = 0; 
TIM_TimeBaseInit(TIM2, &TIM_BaseInitStructure); 

//жϣһжϺж 
TIM_ClearFlag(TIM2, TIM_FLAG_Update); 
//ʹTIM1жԴ 
TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE); 
//TIM1ܿأ 
TIM_Cmd(TIM2, ENABLE); 
} 

void USART_Configuration()
{
  USART_InitTypeDef USART_InitStructure;
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
  /* Configure USARTx_Tx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;			
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  /* Configure USARTx_Rx as input floating */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;				
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	  
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  USART_InitStructure.USART_BaudRate = 115200;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No ;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
  USART_Init(USART1, &USART_InitStructure);
  USART_Cmd(USART1, ENABLE);

}



/*******************************************************************************
* Function Name  : Delay
* Description    : Inserts a delay time.
* Input          : nCount: specifies the delay time length.
* Output         : None
* Return         : None
*******************************************************************************/

 


int fputc(int ch,FILE *f)
{
  /* Write a character to the USART */
  USART_SendData(USART1, (u8) ch);

  /* Loop until the end of transmission */
  while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET)
  {
  }

  return ch;
}

u8 SD_TotalSize(void)
{
    FATFS fs;
    FATFS *pfs;
    DWORD clust;
    FRESULT res;         
	
	pfs=&fs;//ָ
    f_mount(0, &fs);
    res = f_getfree("/", &clust, &pfs);//ǸĿ¼Ĭϴ0
    if ( res==FR_OK ) 
    {
        printf("\r\n%d MB ܿռ.\r\n%d MB ÿռ.\r\n",
                (DWORD)(pfs->max_clust - 2) * pfs->csize /2/1024,
                 clust * pfs->csize /2/1024);
	}
	else return 1;
    f_mount(0, NULL);
    return 0;
}	  

//ɨ赱ǰ·ļи ļ
void scan_current_folder(const char* path)
{
    u8 i;
    FILINFO fno;
    DIR dirs;
	FRESULT res;     // FatFs function common result code
	int file=0,document=0;	 //ļ	ļ
	char *fn;
	u8 record[]={"0:/"};
    #if _USE_LFN
    static char lfn[_MAX_LFN * (_DF1S ? 2 : 1) + 1];
    fno.lfname = lfn;
    fno.lfsize = sizeof(lfn);
	#endif
	res=f_opendir(&dirs, path);
    if(res== FR_OK) 
	{
        while ((f_readdir(&dirs, &fno) == FR_OK) && fno.fname[0]) 
		{
            #if _USE_LFN
            fn = *fno.lfname ? fno.lfname : fno.fname;
            #else
            fn = fno.fname;
			#endif
			i = strlen(fn);
            if (fno.fattrib & AM_DIR)//ļ 
			{
			    file++;				
                printf("%s/%12s", path, &fn[0]);        
		    } 
			else 
			{ 
			 document++;
			 printf("%s/%12s%7ld KB ", path, &fn[0],(fno.fsize+512)/1024);
			   
            }	
        }
		if( file==0 )//ļ
		{		   
		    printf("\r\n%33s\r\n","<ļ>");    
		}
		
		if( document==0 )//ļ
		{
		    printf("\r\n%32s\r\n","<ļ>");    
		}
    }
}				